<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Socket Basics</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Socket Basics</h1>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
					    <h2>Objectives</h2>
					    <a href="../objectives.html" target="_blank">Programming with Sockets Objectives</a>
					</section>


					<section>
							<h2>Programming with Sockets</h2>
							<ul>
								<li>Socket Module</li>
								<ul>
								<li>Python's standard interface for the transport layer</li>
								</ul>
								<li> A network socket address consists of an IP address and port number</li>
								<li>The goal of a socket is to communicate processes through the network.</li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h3>Sockets Intro</h3>
						<ul>
							<li>Server(the listener)</li>
							<li>Client</li>
							<li>Transmission channel</li>
							<li>Protocol</li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h3>Main applications for Sockets</h3>
						<ul>
							<li>Server</li>
							<li>Client</li>
							<li>Client/Server</li>
							
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
                    <section>
						<h2>Socket Module</h2>
						<ul>
							<li>Types and functions found in Socket module</li>
					<pre>
					<code  class="python" data-trim data-noescape>
					>>> import socket
					>>> dir(socket)
					</code>
					</pre>
	
							
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
                    </section>
                    <section>
                        <h2>Constants</h2>
						<pre>
							<code  class="python" data-trim data-noescape>
							socket.AF_INET
							socket.SOCK_STREAM
							</code>
						</pre>
						<li>A typical call to build a socket that works at the TCP level is:</li>
						<pre>
							<code  class="python" data-trim data-noescape>
								socket.socket(socket.AF_INET, socket.SOCK_STREAM)
							</code>
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Socket Methods</h2>
						<ul>
							<li>These are the general socket methods we can use in both clients and servers</li>
							<pre>
								<code  class="python" data-trim data-noescape>
									socket.socket(socket.AF_INET, socket.SOCK_STREAM)
								</code>
							</pre>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
					<section>
						<h2>Socket Module in Python</h2>
						<li>To create a socket, the <code>socket.socket()</code> constructor is used</li>
							<li>By default, the <code><mark>AF_INET</mark></code> family and the <code><mark>SOCK_STREAM</mark></code> type are used</li>
							<aside class="notes">
								Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
							</aside>
						</section>
					<section>
						<h2>General Syntax</h2>
						<pre>
							<code  data-trim data-noescape>socket.socket(socket_family, socket_type, protocol=0)</code></pre>
						<ul>
							<li>the parameters are as follows:</li>
								<ul><pre><code   data-trim data-noescape>socket_family:</code></pre></ul>
								<ul><pre><code data-trim data-noescape>socket_type:</code></pre></ul>
								<ul><pre><code  data-trim data-noescape>protocol:</code> </pre></ul>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h2>General Socket Methods</h2>
						<ul>
							<ul><pre><code   data-trim data-noescape>socket.recv(buflen):</code></pre></ul>
							<ul><pre><code data-trim data-noescape>socket.recvfrom(buflen):</code></pre></ul>
							<ul><pre><code  data-trim data-noescape>socket.recv_into(buffer):</code> </pre></ul>

							</ul>
							<aside class="notes">
								Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
							</aside>
					</section>
					<section>
						<h2>General Socket Methods</h2>
						<ul>
							<li>continued</li>
								<ul><pre><code data-trim data-noescape>socket.recvfrom_into(buffer)</code></pre></ul>
								<ul><pre><code data-trim data-noescape>socket.send(bytes)</code></pre></ul>
								<ul><pre><code  data-trim data-noescape>socket.sendall(data)</code> </pre></ul>
								<ul><pre><code  data-trim data-noescape>socket.close()</code> </pre></ul>
						
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h2>Socket Types</h2>
						<ul>
							<li><code>SOCK_STREAM:</code> It is associated with the TCP protocol </li>
							<li><code>SOCK_DGRAM:</code> It is associated with the UDP protocol </li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>socket.getservbyport(port[, protocol_name]) method</p>
						<pre>
							<code  class="python" data-trim data-noescape>
								>>> import socket
								>>> socket.getservbyport(80)
								'http'
								>>> socket.getservbyport(23)
								'telnet'
							</code>
							
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>Get information about the service name at the application level if we pass the protocol name as a second parameter</p>
						<pre>
							<code  class="python" data-trim data-noescape>
								#!/usr/bin/env python3
								import socket

								def find_service_name():
									protocolname = 'tcp'
									for port in [80, 25]:
										print ("Port: %s => service name: %s" %(port, socket.getservbyport(port, protocolname)))
									print ("Port: %s => service name: %s" %(53, socket.getservbyport(53, 'udp')))
								
								if __name__ == '__main__':
									find_service_name()
							</code>
							
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>Output:</p>
						<pre>
							<code  class="python" data-trim data-noescape>
								Port: 80 => service name: http
								Port: 25 => service name: smtp
								Port: 53 => service name: domain
							</code>
							
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>the socket.gethostbyname(hostname) method</p>
						<pre>
							<code  class="python" data-trim data-noescape>
								>> import socket
								>> >>> socket.gethostbyname('cnn.com')
								'151.101.1.67'
								>> socket.gethostbyname('google.com')
								'216.58.210.142'
							</code>
							
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
					<h2>Creating a TCP Client</h2>
						<pre>
							<code  class="python" data-trim data-noescape>
							import socket

							HOST = 'www.yahoo.com'
							PORT = 80
							BUFSIZ = 4096
							ADDR = (HOST, PORT)

							if __name__ == '__main__':
								client_sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
								client_sock.connect(ADDR)
								while True:
									data = 'GET / HTTP/1.0\r\n\r\n'
									if not data:
										break
									client_sock.send(data.encode('utf-8'))
									data = client_sock.recv(BUFSIZ)
									if not data:
										break
									print(data.decode('utf-8'))
								client_sock.close()
							</code>
						
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>

					</section>
				<section>
					<h2>Client Socket Methods</h2>
					<p>To connect to a remote socket in one direction, we can use the <code>connect()</code> method by using the connect (host, port) format:</p>
					<pre>
						<code  class="python" data-trim data-noescape>
						import socket

						# a socket object is created for communication
						client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
						# now connect to the web server on port 80
						client_socket.connect(("www.cnn.com", 80))
					</code>
					</pre>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h2>Server Socket methods</h2>
					<ul>
						<li><code>bind():</code> port our server will be listening to connections</li>
						<li><code>listen(backlog):</code>accept to start listening to connections</li>
						<li><code>accept():</code>used for accepting the following connection:</li>
						
					</ul>	
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h2>Server Socket methods</h2>
					<pre>
						<code  class="python" data-trim data-noescape>
							import socket

							serversocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
							#bind the socket to localhost on port 80
							serversocket.bind(('localhost', 80))
							#become a server socket and listen a maximum of 10 connections
							serversocket.listen(10)
					</code>
					</pre>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h2>Basic Client</h2>
					<pre>
						<code  class="python" data-trim data-noescape>
							import socket

							serversocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
							#bind the socket to localhost on port 80
							serversocket.bind(('localhost', 80))
							#become a server socket and listen a maximum of 10 connections
							serversocket.listen(10)
					</code>
					</pre>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h3>Socket Demos</h3>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h3>Socket Performance labs</h3>
					<ul>
						<li><a href="../lab-1-2.md">Lab 1-2(1A-1D)</a></li>
					</ul>
				</section>


				
                

			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
